;; -*- mode: scheme; coding: utf-8 -*-

;;;; Copyright (C) 2011, 2012
;;;; Free Software Foundation, Inc.
;;;;
;;;; This library is free software; you can redistribute it and/or
;;;; modify it under the terms of the GNU General Public License as
;;;; published by the Free Software Foundation; either version 3 of
;;;; the License, or (at your option) any later version.
;;;; 
;;;; This library is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;; General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with this library; if not, write to the Free Software
;;;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
;;;; 02110-1301 USA
;;;;

;;; Commentary:

;;; Code:


(define-module (nbs str2nb)
  ;; guile
  :use-module (ice-9 format)

  ;; common
  :use-module (macros reexport)
  :use-module (nbs fp)
  :use-module (strings strings)
  
  :export (string-to-int-rfp-or-string
	   csv-string-to-numbers))


(eval-when (compile load eval)
  (re-export-public-interface (nbs fp)
			      (strings strings)))


(define* (string-to-int-rfp-or-string token #:key (dec 2))
  (let ((nb (string->number token)))
    (if nb
	(if (integer? nb) nb (fp/round nb dec))
	token)))

(define* (csv-string-to-numbers line #:key (sep #\,) (func #f))
  (map (or func string->number) (str/get-tokens line (char-set sep))))


#!

(use-modules (nbs str2nb))
(reload-module (resolve-module '(nbs str2nb)))

(csv-string-to-numbers "19,7812,94.903,243.442,512.250,0.374,1,.917")
(csv-string-to-numbers "Blue	7812	243.442	512.250	0.374	1	.917"
		       #:sep #\Tab
		       #:func string-to-int-rfp-or-string)


!#

